/*
 * lab0.c
 *
 */


#include <avr/io.h>
#define F_CPU 16000000

#include <util/delay.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

void sth_random() {
	int i = 0;
	
	while(i != 7){
			PORTC=0b11111111;
			PORTD=0b11001100;
			PORTA=0b11111111;
			_delay_ms(100);
			
			PORTC=0b11111111;
			PORTD=0b11000100;
			PORTA=0b11111111;
			_delay_ms(100);
			
			PORTD=0b11001100;
			PORTA=0b11111111;
			PORTC=0b11111111;
			
			_delay_ms(100);
			
			PORTD=0b11000100;
			PORTA=0b11111111;
			PORTC=0b10101010;
			_delay_ms(100);
		
		
			PORTD=0b10000100;
			PORTA=0b11111111;
			PORTC=0b01010101;
			_delay_ms(100);	
			
			i++;
	}
		PORTA = 0x00;
		PORTC = 0X00;
		PORTD = 0x00;
}

void spiral()
{
	int i = 0;
	PORTD=0b11001100;
	while(i != 2){	
		PORTC=(1 << PC7);
		_delay_ms(200);	
		
		PORTC=(1 << PC6);
		_delay_ms(200);
		
		PORTC=(1 << PC5);
		_delay_ms(200);
				
		PORTC=(1 << PC4);
		_delay_ms(200);
		
		PORTC=(1 << PC0);
		_delay_ms(200);
		PORTC = 0x00;
		
		PORTA=(1 << PA4);
		_delay_ms(200);
		
		PORTA=(1 << PA3);
		_delay_ms(200);
		
		PORTA=(1 << PA2);
		_delay_ms(200);
		
		PORTA=(1 << PA1);
		_delay_ms(200);
		
		PORTA=(1 << PA0);
		_delay_ms(200);
		
		PORTA=(1 << PA7);
		_delay_ms(200);
		PORTA = 0x00;
		
		PORTC=(1 << PC3);
		_delay_ms(200);
		
		PORTC=(1 << PC2);
		_delay_ms(200);
		
		PORTC=(1 << PC1);
		_delay_ms(200);
		PORTC = 0x00;
		
		PORTA=(1 << PA5);
		_delay_ms(200);
		
		PORTA=(1 << PA6);
		_delay_ms(200);
		
		/* reverse */
		PORTA=(1 << PA5);
		_delay_ms(200);
		
		PORTA = 0x00;
		
		PORTC=(1 << PC1);
		_delay_ms(200);
		
		PORTC=(1 << PC2);
		_delay_ms(200);
		
		PORTC=(1 << PC3);
		_delay_ms(200);
		
		PORTC = 0x00;
		
		PORTA=(1 << PA7);
		_delay_ms(200);
		
		PORTA=(1 << PA0);
		_delay_ms(200);
		
		PORTA=(1 << PA1);
		_delay_ms(200);
		
		PORTA=(1 << PA2);
		_delay_ms(200);
		
		PORTA=(1 << PA3);
		_delay_ms(200);
		
		PORTA=(1 << PA4);
		_delay_ms(200);
		
		PORTA = 0x00;
		
		PORTC=(1 << PC0);
		_delay_ms(200);
		
		PORTC=(1 << PC4);
		_delay_ms(200);	
		
		PORTC=(1 << PC5);
		_delay_ms(200);
		
		PORTC=(1 << PC6);
		_delay_ms(200);
				
		PORTC=(1 << PC7);
		_delay_ms(200);
		i++;
	}
}

/* contains the mapping of a layer */
int layer[16] = {PA0, PA1, PA2, PA3, PA7, PA6, PA5, PA4, PC3, PC2, PC1, PC0, PC7, PC6, PC5, PC4};
/* contains the levels starting with top */
int levels[4] = {PD5, PD4, PD1, PD0};

void rain_effect()
{
	int i = 20;
	int idx;
	int pos1, pos2;
	
	while(i){
		/* generate position of rain drops */
		pos1 = rand() % 16;
		pos2 = rand() % 15;
		
		for (idx = 0; idx < 4; idx++){
			if (pos1 <= 7){
				PORTA=(1 << layer[pos1]);
			}else{
				PORTC=(1 << layer[pos1]);
			}
			
			if (pos2 <= 7){
				PORTA=(1 << layer[pos2]);
			}else{
				PORTC=(1 << layer[pos2]);
			}
			
			PORTD=(1 << levels[idx]);
			_delay_ms(300/(idx+1));
			PORTA = 0x00;
			PORTC = 0x00;
		}
		i--;
	}
}

void full()
{
	int i = 10;
	while(i){
		PORTA = 0xFF;
		PORTC = 0xFF;
		PORTD = 0b11001100;
		_delay_ms(100);
		i--;
	}
	PORTA = 0x00;
	PORTC = 0x00;
	PORTD = 0x00;
}

void sth_2D()
{
	int i, idx;
	i = 4;
	
	while(i){
		for (idx = 0; idx < 8; idx++){
			if (idx == 0){
				PORTA = 0b11110000;
				PORTD = (1 << PD0);
			}else if (idx == 1){
				PORTA = 0b00001111;
				PORTD = (1 << PD1);
			}else if (idx == 2){
				PORTC = 0b11110000;
				PORTD = (1 << PD4);
			}else if (idx == 3){
				PORTC = 0b00001111;
				PORTD = (1 << PD5);
			}else if (idx == 4){
				PORTC = 0b00001111;
				PORTD = (1 << PD4);
			}else if (idx == 5){
				PORTC = 0b00001111;
				PORTD = (1 << PD1);
			}else if (idx == 6){
				PORTC = 0xFF;
				PORTA = 0xFF;
				PORTD = (1 << PD0);
			}
			_delay_ms(100);
		}
		i--;
	}
}

int main(void) {
	DDRA |= 0xFF;
	DDRC |= 0xFF;
	DDRD |= (1 << PD0);
	DDRD |= (1 << PD1);
	DDRD |= (1 << PD4);
	DDRD |= (1 << PD5);
	
	while(1){
		full();
		sth_random();
		spiral();
		rain_effect();
		sth_2D();
	}
	
	return 0;
}

